﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class LevelControl : MonoBehaviour
{
    static public int highScore = 0;

    public GameObject appleTreePrefab;

    public Text scoreGT;
    public Text levelUI;
    static public int yourScore;
    public int level;

    //难度系数
    public float speed = 10f;
    public float leftAndRightEdge = 20f;
    public float chanceToChangeDirections = 0.02f;
    public float secondsBetweenAppleDrops = 1f;
    public int treeNum = 1;

    // Start is called before the first frame update
    void Awake()
    {
        if (PlayerPrefs.HasKey("ApplePickerHighScore"))
        {
            highScore = PlayerPrefs.GetInt("ApplePickerHighScore");
        }
        else
        {
            PlayerPrefs.SetInt("ApplePickerHighScore", highScore);
        }
    }

    void Start()
    {

        //计分板初始化
        GameObject scoreGO = GameObject.Find("ScoreCounter");
        scoreGT = scoreGO.GetComponent<Text>();
        yourScore = 0;
        scoreGT.text = "Your Score: " + yourScore;

        //关卡初始化
        GameObject levelGO = GameObject.Find("LevelCounter");
        levelUI = levelGO.GetComponent<Text>();
        level = 1;
        levelUI.text = "Level: " + level;
        speed = 10f + (level - 1) * 10;
        secondsBetweenAppleDrops = 1f - (level - 1) * 0.3f;
        treeNum = 1;

        Vector3 pos = Vector3.zero;
        pos.y = 12;
        GameObject appleTree = Instantiate(appleTreePrefab) as GameObject;
        appleTree.transform.position = pos;

    }

    // Update is called once per frame
    void LateUpdate()
    {
        if (yourScore - level * 10 >= 0) 
        {
            //关卡更新
            level += 1;
            levelUI.text = "Level: " + level;

            //难度更新
            speed = 10f + (level - 1) * 10;
            if (speed >= 80) speed = 80;
            if (treeNum >= 2) 
            { 
                secondsBetweenAppleDrops = 0.6f + treeNum * 0.2f;
                speed = 60;
            }
            else
            {
                secondsBetweenAppleDrops = 1f - (level - 1) * 0.3f;
                if (secondsBetweenAppleDrops < 0.1f) { secondsBetweenAppleDrops = 0.1f; }
            }

        }
        if (level - treeNum * 10 >= 0&&treeNum<=10) 
        {
            treeNum += 1;
            Vector3 pos = Vector3.zero;
            pos.y = 12;
            GameObject appleTree = Instantiate(appleTreePrefab) as GameObject;
            appleTree.transform.position = pos;
        }
    }

    public void ApplePicked()
    {
        //计分
        yourScore += 1;
        scoreGT.text = "Your Score: " + yourScore;
    }
}
